local module = DMod:new("diamond_heist_detection_meter", {
	abbr = "dhdetectionmeter",
	name = "Diamond Heist Detection Meter",
	author = "Buurazu",  
	version = "1.1",
	description = {
		english = "Adds a detection meter to Diamond Heist stealth and First World Bank casing, using the hint display and waypoints"
	},
})

module:hook_post_require("lib/units/enemies/cop/logics/coplogicsecurityonduty", "coplogicsecurityonduty")
module:hook_post_require("lib/units/enemies/cop/logics/coplogicattack", "coplogicattack")
module:hook_post_require("lib/managers/hintmanager", "hintmanager")
module:hook_post_require("lib/managers/group_ai_states/groupaistatebase", "groupaistatebase")

--for Diamond Heist clients
module:hook_post_require("lib/units/enemies/cop/copmovement", "copmovement")

local function _add_localization_string(data, language)
	for string, text in pairs(data) do
		local loc_data = {}
		loc_data[language] = text
		module:add_localization_string(string, loc_data)
	end
end

_add_localization_string({
	hud_dhdm_hint_detection = "$PERCENTAGE;%",
}, "english")
-- register module
return module