
local module = D:module('diamond_heist_detection_meter')

module:hook(CopLogicAttack, "_detect_enemies", function(data, my_data)
	local ret = module:call_orig(CopLogicAttack, "_detect_enemies", data, my_data)
	local is_dh = Global.level_data.level_id == "diamond_heist"
	--only run as host on Diamond Heist during whisper mode
	if (not Network:is_server() or not is_dh or not managers.groupai:state():whisper_mode()) then return ret end
	
	local enemies = managers.groupai:state():whisper_mode() and managers.groupai:state():all_player_criminals() or managers.groupai:state():all_criminals()
	
	local key_str = tostring(data.unit:key())
	
	local suspicious = false
	--dorhud_log(key_str .. " DID A DETECT")
	
	for e_key, e_data in pairs(enemies) do
		--only care about ourselves
		if (e_data.unit:base().is_local_player) then
			local suspect_data = my_data.suspected_enemies[e_key]
			if (suspect_data and suspect_data.detection_countdown) then
				suspicious = true
				managers.groupai:state()._dhdm_guards[key_str] = suspect_data.detection_countdown
				--dorhud_log("DETECTION: " .. suspect_data.detection_countdown)
			end
		--else
			--dorhud_log("NOT LOCAL PLAYER " .. tostring(e_key))
		end
	end
	
	if (not suspicious) then
		managers.groupai:state()._dhdm_guards[key_str] = nil
	end
	
	return ret
end)
