
local module = D:module('diamond_heist_detection_meter')

module:hook(CopMovement, "update", function(self, unit, t, dt)
	module:call_orig(CopMovement, "update", self, unit, t, dt)
	
	local is_dh = Global.level_data.level_id == "diamond_heist"
	--only run as client on Diamond Heist during whisper mode
	if (Network:is_server() or not is_dh or not managers.groupai:state():whisper_mode()) then return end
	
	local key_str = tostring(unit:key())
	--dorhud_log("COPMOVEMENT UPDATE FOR " .. key_str)
	
	--diamond heist guard detection code (CopLogicAttack._detect_enemies) modified to work in copmovement update
	local delay = 1
	local criminal_dis = {}
	local t_ins = table.insert
	local my_pos = unit:movement():m_head_pos()
	local enemies = managers.groupai:state():whisper_mode() and managers.groupai:state():all_player_criminals() or managers.groupai:state():all_criminals()
	local my_tracker = unit:movement():nav_tracker()
	local chk_vis_func = my_tracker.check_visibility
	
	for e_key, e_data in pairs(enemies) do
		if (e_data.unit:base().is_local_player) then
			local enemy_unit = e_data.unit
			
			if enemy_unit:in_slot(managers.slot:get_mask("criminals")) then
				
				if managers.groupai:state()._dhdm_guards[key_str] then
					--local suspect_data = my_data.suspected_enemies[e_key]
					local interval_dt = dt
					local visible
					local my_pos = unit:movement():m_head_pos()
					local enemy_pos = enemy_unit:movement():m_head_pos()
					local enemy_vec = enemy_pos - my_pos
					local enemy_dis = mvector3.normalize(enemy_vec)
					local dis_multiplier, angle_multiplier
					dis_multiplier = enemy_dis / 1100
					if dis_multiplier < 1 then
						delay = 0
						local my_fwd = unit:movement():m_head_rot():z()
						local enemy_dot = mvector3.dot(my_fwd, enemy_vec)
						local enemy_angle = math.acos(enemy_dot)
						local max_angle = math.lerp(180, 80, math.clamp((enemy_dis - 150) / 600, 0, 1))
						angle_multiplier = enemy_angle / max_angle
						if angle_multiplier < 1 and not World:raycast("ray", my_pos, enemy_pos, "slot_mask", managers.slot:get_mask("AI_visibility"), "ray_type", "ai_vision") then
							visible = true
						end

					end

					if visible then
						local total_mult = 1 - math.min(1, dis_multiplier) * math.min(1, angle_multiplier)
						--managers.hint:show_hint("dhdm_hint_detection",nil, false, {PERCENTAGE = total_mult})
						--managers.hint:show_hint("dhdm_hint_detection",nil, false, {PERCENTAGE = mvector3.z(enemy_pos)})
						managers.groupai:state()._dhdm_guards[key_str] = managers.groupai:state()._dhdm_guards[key_str] - interval_dt * total_mult
						if 0 > managers.groupai:state()._dhdm_guards[key_str] then
							--max 100%
							managers.groupai:state()._dhdm_guards[key_str] = 0
						end

					else
						managers.groupai:state()._dhdm_guards[key_str] = managers.groupai:state()._dhdm_guards[key_str] + interval_dt
						if managers.groupai:state()._dhdm_guards[key_str] > 1 then
							managers.groupai:state()._dhdm_guards[key_str] = nil
						end

					end

				else
					local visible
					if chk_vis_func(my_tracker, e_data.tracker, e_data.tracker) then
						local my_pos = unit:movement():m_head_pos()
						local enemy_pos = enemy_unit:movement():m_head_pos()
						local enemy_vec = enemy_pos - my_pos
						local enemy_dis = mvector3.normalize(enemy_vec)
						local dis_multiplier, angle_multiplier
						dis_multiplier = enemy_dis / 1100
						if dis_multiplier < 1 then
							delay = math.min(delay, dis_multiplier)
							local my_fwd = unit:movement():m_head_rot():z()
							local enemy_dot = mvector3.dot(my_fwd, enemy_vec)
							local enemy_angle = math.acos(enemy_dot)
							local max_angle = math.lerp(180, 80, math.clamp((enemy_dis - 150) / 600, 0, 1))
							angle_multiplier = enemy_angle / max_angle
							if angle_multiplier < 1 and not World:raycast("ray", my_pos, enemy_pos, "slot_mask", managers.slot:get_mask("AI_visibility"), "ray_type", "ai_vision") then
								visible = true
							end

						end

					end

					if visible then
						managers.groupai:state()._dhdm_guards[key_str] = 1
					end

				end

			end
		end
	end
end)