local module = DorHUD:module('diamond_heist_detection_meter')
local HintManager = module:hook_class("HintManager")

function HintManager:DHDMaddCustomHint(str, data)

	Global.hint_manager.hints[str] = {
		text_id = "hud_"..str,
		trigger_times = nil,
		trigger_count = 0,
		sync = false,
		event = nil,
		level = nil
	}
	
end

module:hook(HintManager, "init", function(self, ...)
	module:call_orig(HintManager, "init", self, ...)
	self:DHDMaddCustomHint("dhdm_hint_detection")
end)

module:hook(HintManager, "show_hint", function(self, id, ...)
	local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD)
	if not hud then
		module:call_orig(HintManager, "show_hint", self, id, ...)
		return
	end
	
	--place our detection hint at the center of the screen
	if (id == "dhdm_hint_detection") then
		hud.hint_text:set_h(64)
		hud.hint_shadow_text:set_h(64)
		
		hud.hint_text:set_font_size(tweak_data.hud.timer_font_size)
		hud.hint_shadow_text:set_font_size(tweak_data.hud.timer_font_size)
		
		local x = hud.hint_text:parent():center_x()
		local y = hud.hint_text:parent():center_y() / 1.5
		hud.hint_text:set_center(x, y)
		hud.hint_shadow_text:set_center(x, y)
	--reset the hint display to be normal
	else
		hud.hint_text:set_h(32)
		hud.hint_shadow_text:set_h(32)
		
		hud.hint_text:set_font_size(tweak_data.hud.hint_font_size)
		hud.hint_shadow_text:set_font_size(tweak_data.hud.hint_font_size)
		
		local x = hud.hint_text:parent():center_x()
		local y = hud.hint_text:parent():center_y() / 2.5
		hud.hint_text:set_center(x, y)
		hud.hint_shadow_text:set_center(x, y)
	end
	module:call_orig(HintManager, "show_hint", self, id, ...)
end)